/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Indexes;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreGroup.TCoreGroupPath;
import de.ship.db.tables.TCorePerson.TCorePersonPath;
import de.ship.db.tables.records.TCoreUsergroupRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreUsergroup extends TableImpl<TCoreUsergroupRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_usergroup</code>
     */
    public static final TCoreUsergroup T_CORE_USERGROUP = new TCoreUsergroup();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreUsergroupRecord> getRecordType() {
        return TCoreUsergroupRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_usergroup.lastchange</code>.
     */
    public final TableField<TCoreUsergroupRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_usergroup.pk</code>. unique id
     */
    public final TableField<TCoreUsergroupRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "unique id");

    /**
     * The column <code>common_dd.t_core_usergroup.fk_usnr</code>. reference to
     * user
     */
    public final TableField<TCoreUsergroupRecord, Integer> FK_USNR = createField(DSL.name("fk_usnr"), SQLDataType.INTEGER.nullable(false), this, "reference to user");

    /**
     * The column <code>common_dd.t_core_usergroup.fk_group</code>. reference to
     * group
     */
    public final TableField<TCoreUsergroupRecord, Integer> FK_GROUP = createField(DSL.name("fk_group"), SQLDataType.INTEGER.nullable(false), this, "reference to group");

    private TCoreUsergroup(Name alias, Table<TCoreUsergroupRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreUsergroup(Name alias, Table<TCoreUsergroupRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_usergroup</code> table reference
     */
    public TCoreUsergroup(String alias) {
        this(DSL.name(alias), T_CORE_USERGROUP);
    }

    /**
     * Create an aliased <code>common_dd.t_core_usergroup</code> table reference
     */
    public TCoreUsergroup(Name alias) {
        this(alias, T_CORE_USERGROUP);
    }

    /**
     * Create a <code>common_dd.t_core_usergroup</code> table reference
     */
    public TCoreUsergroup() {
        this(DSL.name("t_core_usergroup"), null);
    }

    public <O extends Record> TCoreUsergroup(Table<O> path, ForeignKey<O, TCoreUsergroupRecord> childPath, InverseForeignKey<O, TCoreUsergroupRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_USERGROUP);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreUsergroupPath extends TCoreUsergroup implements Path<TCoreUsergroupRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreUsergroupPath(Table<O> path, ForeignKey<O, TCoreUsergroupRecord> childPath, InverseForeignKey<O, TCoreUsergroupRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreUsergroupPath(Name alias, Table<TCoreUsergroupRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreUsergroupPath as(String alias) {
            return new TCoreUsergroupPath(DSL.name(alias), this);
        }

        @Override
        public TCoreUsergroupPath as(Name alias) {
            return new TCoreUsergroupPath(alias, this);
        }

        @Override
        public TCoreUsergroupPath as(Table<?> alias) {
            return new TCoreUsergroupPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public List<Index> getIndexes() {
        return Arrays.asList(Indexes.IDX_CORE_USERGROUP_GROUP, Indexes.IDX_CORE_USERGROUP_USNR);
    }

    @Override
    public Identity<TCoreUsergroupRecord, Integer> getIdentity() {
        return (Identity<TCoreUsergroupRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreUsergroupRecord> getPrimaryKey() {
        return Keys.PK_CORE_USERGROUP;
    }

    @Override
    public List<UniqueKey<TCoreUsergroupRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_CORE_USERGROUP);
    }

    @Override
    public List<ForeignKey<TCoreUsergroupRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_USERGROUP__FK_CORE_USERGROUP_USNR, Keys.T_CORE_USERGROUP__FK_CORE_USERGROUP_GROUP);
    }

    private transient TCorePersonPath _tCorePerson;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_person</code>
     * table.
     */
    public TCorePersonPath tCorePerson() {
        if (_tCorePerson == null)
            _tCorePerson = new TCorePersonPath(this, Keys.T_CORE_USERGROUP__FK_CORE_USERGROUP_USNR, null);

        return _tCorePerson;
    }

    private transient TCoreGroupPath _tCoreGroup;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_group</code>
     * table.
     */
    public TCoreGroupPath tCoreGroup() {
        if (_tCoreGroup == null)
            _tCoreGroup = new TCoreGroupPath(this, Keys.T_CORE_USERGROUP__FK_CORE_USERGROUP_GROUP, null);

        return _tCoreGroup;
    }

    @Override
    public TCoreUsergroup as(String alias) {
        return new TCoreUsergroup(DSL.name(alias), this);
    }

    @Override
    public TCoreUsergroup as(Name alias) {
        return new TCoreUsergroup(alias, this);
    }

    @Override
    public TCoreUsergroup as(Table<?> alias) {
        return new TCoreUsergroup(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreUsergroup rename(String name) {
        return new TCoreUsergroup(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreUsergroup rename(Name name) {
        return new TCoreUsergroup(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreUsergroup rename(Table<?> name) {
        return new TCoreUsergroup(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUsergroup where(Condition condition) {
        return new TCoreUsergroup(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUsergroup where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUsergroup where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUsergroup where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreUsergroup where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreUsergroup where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreUsergroup where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreUsergroup where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUsergroup whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUsergroup whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
